gtkmm 4.10.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::ShortcutAction Class Reference
Event Controllers and Gestures

Tracking if shortcuts should be activated. More...

`#include <gtkmm/shortcutaction.h>`

Inheritance diagram for Gtk::ShortcutAction:
[legend]

## Public Types
enum class | Flags { EXCLUSIVE = 1 << 0 }
| List of flags that can be passed to action activation. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| ShortcutAction (ShortcutAction && src) noexcept
ShortcutAction & | operator= (ShortcutAction && src) noexcept
| ~ShortcutAction () noexcept override
GtkShortcutAction * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkShortcutAction * | gobj () const
| Provides access to the underlying C GObject. More...
GtkShortcutAction * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | to_string () const
| Prints the given action into a human-readable string. More...
bool | activate (Widget & widget, Flags flags=static_cast< Flags >(0), const Glib::VariantBase & args={})
| Activates the action on the widget with the given args. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ShortcutAction > | parse_string (const Glib::ustring &string)
| Tries to parse the given string into an action. More...

## Protected Member Functions
| ShortcutAction ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::ShortcutAction > | wrap (GtkShortcutAction * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Tracking if shortcuts should be activated.

Gtk::ShortcutAction is the object used to describe what a Gtk::Shortcut should do when triggered. To activate a ShortcutAction manually, activate() can be called.

ShortcutActions contain methods that allow easy presentation to end users as well as being printed for debugging.

All ShortcutActions are immutable, you can only specify their properties during construction. If you want to change an action, you have to replace it with a new one. If you need to pass arguments to an action, these are specified by the higher-level Gtk::Shortcut object.

GTK provides various actions:

- Gtk::MnemonicAction: a shortcut action that calls Gtk::Widget::mnemonic_activate()
- Gtk::CallbackAction: a shortcut action that invokes a given callback
- Gtk::SignalAction: a shortcut action that emits a given signal
- Gtk::ActivateAction: a shortcut action that calls Gtk::Widget::activate()
- Gtk::NamedAction: a shortcut action that calls Gtk::Widget::activate_action()
- Gtk::NothingAction: a shortcut action that does nothing

See also
  Gtk::Shortcut

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ ShortcutAction() [1/2]

Gtk::ShortcutAction::ShortcutAction | ( | ShortcutAction && | src | ) |
| noexcept

## ◆ ~ShortcutAction()

Gtk::ShortcutAction::~ShortcutAction | ( |  | ) |
| override noexcept

## ◆ ShortcutAction() [2/2]

Gtk::ShortcutAction::ShortcutAction | ( |  | ) |
| protected

## Member Function Documentation

## ◆ activate()

bool Gtk::ShortcutAction::activate | ( | Widget & | widget,
|  | Flags | flags = `static_cast< Flags >(0)`,
|  | const Glib::VariantBase & | args = `{}`
| ) |  |

Activates the action on the widget with the given args.

Note that some actions ignore the passed in flags, widget or args.

Activation of an action can fail for various reasons. If the action is not supported by the widget, if the args don't match the action or if the activation otherwise had no effect, `false` will be returned.

Parameters

  flags | Flags to activate with.
  widget | Target of the activation.
  args | Arguments to pass.

Returns
  `true` if this action was activated successfully.

## ◆ get_type()

static GType Gtk::ShortcutAction::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkShortcutAction* Gtk::ShortcutAction::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkShortcutAction* Gtk::ShortcutAction::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkShortcutAction* Gtk::ShortcutAction::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

ShortcutAction& Gtk::ShortcutAction::operator= | ( | ShortcutAction && | src | ) |
| noexcept

## ◆ parse_string()

static Glib::RefPtr<ShortcutAction> Gtk::ShortcutAction::parse_string | ( | const Glib::ustring & | string | ) |
| static

Tries to parse the given string into an action.

On success, the parsed action is returned. When parsing failed, `nullptr` is returned.

The accepted strings are:

- `nothing`, for `Gtk::NothingAction`
- `activate`, for `Gtk::ActivateAction`
- `mnemonic-activate`, for `Gtk::MnemonicAction`
- `action(NAME)`, for a `Gtk::NamedAction` for the action named `NAME`
- `signal(NAME)`, for a `Gtk::SignalAction` for the signal `NAME`

Parameters

  string | The string to parse.

Returns
  A new `Gtk::ShortcutAction`.

## ◆ to_string()

Glib::ustring Gtk::ShortcutAction::to_string | ( |  | ) | const

Prints the given action into a human-readable string.

This is meant for debugging and logging. The form of the representation may change at any time and is not guaranteed to stay identical.

Returns
  A new string.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::ShortcutAction > wrap | ( | GtkShortcutAction * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.